var rdrPref = {
  prefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.rdr.'),
  init: function() {
	  this.list=document.getElementById('permissionsBox');
		this._bundle = document.getElementById("bundlePreferences");
	  this.fillList(); // Fills ignore-List
    document.getElementById('chbWhitelist').checked  =this.prefs.getBoolPref('contextmenu.whitelist');
    document.getElementById('chbContextOpen').checked=this.prefs.getBoolPref('contextmenu.contextopen');
    document.getElementById('chbCopyClean').checked  =this.prefs.getBoolPref('contextmenu.copyclean');
    document.getElementById('chbCleanImages').checked=this.prefs.getBoolPref('cleanImages');
    document.getElementById('chbStatusButton').checked=this.prefs.getBoolPref('statusbutton');
		document.getElementById("removeAllPermissions").disabled = this.list.getRowCount() == 0;
  },
		
  onHostInput: function (aSiteField) {
    document.getElementById("btnAllow").disabled = !aSiteField.value.replace(/^\s*([-\w]*:\/+)?/, "");
  },
	
	save: function () {
    this.prefs.setBoolPref('cleanImages',document.getElementById('chbCleanImages').checked);
    this.prefs.setBoolPref('contextmenu.contextopen',document.getElementById('chbContextOpen').checked);
    this.prefs.setBoolPref('contextmenu.whitelist',document.getElementById('chbWhitelist').checked);
    this.prefs.setBoolPref('contextmenu.copyclean',document.getElementById('chbCopyClean').checked);
    this.prefs.setBoolPref('statusbutton',document.getElementById('chbStatusButton').checked);
    this.prefs.setCharPref('whitelist',this.getListBoxValues());  
  },
  	
	fillList:	function () {
		var items,item,prefIgnore=this.prefs.getCharPref('whitelist');
		if((prefIgnore.replace(/^\s*|\s*$/g,"")).length==0) return;
		items=prefIgnore.split(' ');
		for(var i=0;i<items.length;i++)
			this.list.appendItem(items[i], items[i]);	
	},
	
	addPermission: function () {
    var textbox = document.getElementById("url");
    var host = textbox.value.toLowerCase();
    if(host.indexOf('*')==-1) { // Normal URL matching
      host = host.replace(/^\s*([-\w]*:\/+)?/, ""); // trim any leading space and scheme
  		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      try {
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var uri = ioService.newURI("http://"+host, null, null);
      } catch(ex) {
        var message = this._bundle.getString("invalidURI");
        var title = this._bundle.getString("invalidURITitle");
        promptService.alert(window, title, message);
  			textbox.focus();
        return;
      }
  		host=host.match(/^[^/?]+/);
      host=host[0];
    } else host = host.replace(/^\**|\**$/g,"").replace(/\*+/g,"*"); // Trims asteriks, removes double (or more) asteriks 

    
    // check whether the permission already exists, if not, add it
    var exists = false;
    for(var i=0;i<this.list.getRowCount();i++) {
      if (this.list.getItemAtIndex(i).label.toLowerCase() == host) {
        exists = true;
        break;
      }
    }
    
    if (!exists) this.list.appendItem(host, host)
    textbox.value = "";
    textbox.focus();

    // covers a case where the site exists already, so the buttons don't disable
    this.onHostInput(textbox);

    // enable "remove all" button as needed
    document.getElementById("removeAllPermissions").disabled = this.list.getRowCount() == 0;
  },
	
	onPermissionKeyPress: function (aEvent) {
    if (aEvent.keyCode == 46)
      this.onPermissionDeleted();
  },
	
	onPermissionSelected: function () {
    var hasSelection = this.list.selectedCount > 0;
    var hasRows = this.list.getRowCount() > 0;
    document.getElementById("removePermission").disabled = !hasRows || !hasSelection;
    document.getElementById("removeAllPermissions").disabled = !hasRows;
  },
	
	onPermissionDeleted: function () {
    if (!this.list.getRowCount()) return;
		var itemId=this.list.getIndexOfItem(this.list.getSelectedItem(0));
    this.list.removeItemAt(itemId);
    document.getElementById("removePermission").disabled = !this.list.getRowCount();
    document.getElementById("removeAllPermissions").disabled = !this.list.getRowCount();
		if(this.list.getRowCount()) this.list.selectedIndex=itemId == 0?0:itemId-1;
  },
	
	onAllPermissionsDeleted: function () {
    if (!this.list.getRowCount()) return;
		while(this.list.getRowCount()) this.list.removeItemAt(0);
    document.getElementById("removePermission").disabled = true;
    document.getElementById("removeAllPermissions").disabled = true;
  },
	
	getListBoxValues: function() {
	  var newList='';
	  for(i=0;i<this.list.getRowCount();++i) newList+=this.list.getItemAtIndex(i).label+' ';
		return newList.substr(0,newList.length-1);
	}
}
